source slinke.tcl

set slinkeport "/dev/ttyS0"

# this file is the slinke-server,
# waits for commands on port 5000
# sends signals to the slinke over $slinkeport

proc handleSock {sock} {
  if {[eof $sock] || [catch {gets $sock line}]} {
    # Check end of file or abnormal connection drop
    close $sock
    puts "connection drop, close $sock"
  } else {

      global slinkeport


      # initialize the slinke and load the stored codes
      Slinke::init
      Slinke::connect $slinkeport
      Slinke::load "devices/web.buttons"

      # depending on the command we are sent (0-23),
      # send out different signals to the slinke

      # output to dvd
      if {$line == 0} {Slinke::recall "power" "IR" "1" "dvd-"}
      if {$line == 1} {Slinke::recall "rew" "IR" "1" "dvd-"}
      if {$line == 2} {Slinke::recall "play" "IR" "1" "dvd-"}
      if {$line == 3} {Slinke::recall "pause" "IR" "1" "dvd-"}
      if {$line == 4} {Slinke::recall "stop" "IR" "1" "dvd-"}
      if {$line == 5} {Slinke::recall "ff" "IR" "1" "dvd-"}
      if {$line == 12} {Slinke::recall "open_close" "IR" "1" "dvd-"}

      # VCR power seems weak, so repeat it
      if {$line == 6} {Slinke::recall "power" "IR" "3" "vcr-"}
      if {$line == 7} {Slinke::recall "rew" "IR" "3" "vcr-"}
      if {$line == 8} {Slinke::recall "play" "IR" "6" "vcr-"}
      if {$line == 9} {Slinke::recall "pause" "IR" "3" "vcr-"}
      if {$line == 10} {Slinke::recall "stop" "IR" "9" "vcr-"}
      if {$line == 11} {Slinke::recall "ff" "IR" "3" "vcr-"}

      # for the AV system
      if {$line == 13} {Slinke::recall "video1" "IR" "1" "av-"}
      if {$line == 14} {Slinke::recall "video2" "IR" "1" "av-"}
      if {$line == 15} {Slinke::recall "video3" "IR" "1" "av-"}
      if {$line == 16} {Slinke::recall "ld_dvd" "IR" "1" "av-"}
      if {$line == 17} {Slinke::recall "tv" "IR" "1" "av-"}
      if {$line == 18} {Slinke::recall "tape" "IR" "1" "av-"}
      if {$line == 19} {Slinke::recall "dat_md" "IR" "1" "av-"}
      if {$line == 20} {Slinke::recall "cd" "IR" "1" "av-"}
      if {$line == 21} {Slinke::recall "tuner" "IR" "1" "av-"}
      if {$line == 22} {Slinke::recall "phono" "IR" "1" "av-"}
      if {$line == 23} {Slinke::recall "system_off" "IR" "1" "av-"}

      # disconnect the slinke
      Slinke::disconnect

  }
}

proc handler {port sock client_host client_port} {
  fconfigure $sock -blocking 0
  fconfigure $sock -translation {binary binary}
  
  fileevent $sock readable "handleSock $sock"
}




# Listening on port 5000 for TCP connection
set port 5000
set sock [socket -server "handler $port" $port]
fconfigure $sock -buffering full
fconfigure $sock -buffersize 4096
vwait 0