#!/usr/bin/tclsh
#package require ncgi
#package require html

source ncgi.tcl
source html.tcl

set IMAGE_PATH "/~tmk29/images"
set slinkehost "ankara.clic.cs.columbia.edu"
set slinkeport 5000


#configure the location of device control gateway
# i.e. the slinke server
set s [socket $slinkehost $slinkeport]
fconfigure $s -buffering line

# procedures to print out tables
proc tbl_head {tbl_title} {
	puts "<table border=0 cellpadding=5>"
	puts "<tr>"
	puts "<td class=head>$tbl_title</td>"
	puts "</tr>"
	puts "<tr>"
	puts "<td class=body>"
}

proc tbl_tail {} {
	puts "</td>"
	puts "</tr>"
	puts "</table>"
}

ncgi::header	;# output the http header
ncgi::input	;# get form data via CGI
html::init	;#  initialise the HTML package

#output title and stylesheet information
set title "CLIC Remote Control"
html::headTag "link type=\"text/css\" rel=\"stylesheet\" href=\"style.css\""
puts [html::head  $title]
puts [html::bodyTag]
puts [html::h1 $title]

puts "<form method=post action=web.cgi>"

#display the VCR buttons in a table
tbl_head "VCR"
puts "<input type=image name=\"vcr_pow\" src=\"$IMAGE_PATH/btn_pow.gif\" border=0>"
puts "<input type=image name=\"vcr_rew\" src=\"$IMAGE_PATH/btn_rew.gif\" border=0>"
puts "<input type=image name=\"vcr_play\" src=\"$IMAGE_PATH/btn_play.gif\" border=0>"
puts "<input type=image name=\"vcr_pause\" src=\"$IMAGE_PATH/btn_pause.gif\" border=0>"
puts "<input type=image name=\"vcr_stop\" src=\"$IMAGE_PATH/btn_stop.gif\" border=0>"
puts "<input type=image name=\"vcr_ff\" src=\"$IMAGE_PATH/btn_ff.gif\" border=0>"
tbl_tail

puts "<p><p>"

#display the DVD buttons in a table
tbl_head "DVD"
puts "<input type=image name=\"dvd_pow\" src=\"$IMAGE_PATH/btn_pow.gif\" border=0>"
puts "<input type=image name=\"dvd_opn\" src=\"$IMAGE_PATH/btn_eject.gif\" border=0>"
puts "<input type=image name=\"dvd_rew\" src=\"$IMAGE_PATH/btn_rew.gif\" border=0>"
puts "<input type=image name=\"dvd_play\" src=\"$IMAGE_PATH/btn_play.gif\" border=0>"
puts "<input type=image name=\"dvd_pause\" src=\"$IMAGE_PATH/btn_pause.gif\" border=0>"
puts "<input type=image name=\"dvd_stop\" src=\"$IMAGE_PATH/btn_stop.gif\" border=0>"
puts "<input type=image name=\"dvd_ff\" src=\"$IMAGE_PATH/btn_ff.gif\" border=0>"
tbl_tail

puts "<p><p>"

#display the AV system buttons in a table
tbl_head "AV"
puts "<input type=image name=\"av_sys_off\" src=\"$IMAGE_PATH/btn_av_sys_off.gif\" border=0>"
puts "<br>"
puts "<input type=image name=\"av_video1\" src=\"$IMAGE_PATH/btn_av_video1.gif\" border=0>"
puts "<input type=image name=\"av_video2\" src=\"$IMAGE_PATH/btn_av_video2.gif\" border=0>"
puts "<input type=image name=\"av_video3\" src=\"$IMAGE_PATH/btn_av_video3.gif\" border=0>"
puts "<input type=image name=\"av_lddvd\" src=\"$IMAGE_PATH/btn_av_lddvd.gif\" border=0>"
puts "<input type=image name=\"av_tv\" src=\"$IMAGE_PATH/btn_av_tv.gif\" border=0>"
puts "<br>"
puts "<input type=image name=\"av_tape\" src=\"$IMAGE_PATH/btn_av_tape.gif\" border=0>"
puts "<input type=image name=\"av_datmd\" src=\"$IMAGE_PATH/btn_av_datmd.gif\" border=0>"
puts "<input type=image name=\"av_cd\" src=\"$IMAGE_PATH/btn_av_cd.gif\" border=0>"
puts "<input type=image name=\"av_tuner\" src=\"$IMAGE_PATH/btn_av_tuner.gif\" border=0>"
puts "<input type=image name=\"av_phono\" src=\"$IMAGE_PATH/btn_av_phono.gif\" border=0>"

tbl_tail

puts "</form>"


# now we see if the form was submitted
# and send corresponding command to the slinke-server
if {[ncgi::empty dvd_pow.x] == 0} {puts $s "0"}
if {[ncgi::empty dvd_rew.x] == 0} {puts $s "1"}
if {[ncgi::empty dvd_play.x] == 0} {puts $s "2"}
if {[ncgi::empty dvd_pause.x] == 0} {puts $s "3"}
if {[ncgi::empty dvd_stop.x] == 0} {puts $s "4"}
if {[ncgi::empty dvd_ff.x] == 0} {puts $s "5"}
if {[ncgi::empty dvd_opn.x] == 0} {puts $s "12"}

if {[ncgi::empty vcr_pow.x] == 0} {puts $s "6"}
if {[ncgi::empty vcr_rew.x] == 0} {puts $s "7"}
if {[ncgi::empty vcr_play.x] == 0} {puts $s "8"}
if {[ncgi::empty vcr_pause.x] == 0} {puts $s "9"}
if {[ncgi::empty vcr_stop.x] == 0} {puts $s "10"}
if {[ncgi::empty vcr_ff.x] == 0} {puts $s "11"}

if {[ncgi::empty av_sys_off.x] == 0} {puts $s "23"}
if {[ncgi::empty av_video1.x] == 0} {puts $s "13"}
if {[ncgi::empty av_video2.x] == 0} {puts $s "14"}
if {[ncgi::empty av_video3.x] == 0} {puts $s "15"}
if {[ncgi::empty av_lddvd.x] == 0} {puts $s "16"}
if {[ncgi::empty av_tv.x] == 0} {puts $s "17"}
if {[ncgi::empty av_tape.x] == 0} {puts $s "18"}
if {[ncgi::empty av_datmd.x] == 0} {puts $s "19"}
if {[ncgi::empty av_cd.x] == 0} {puts $s "20"}
if {[ncgi::empty av_tuner.x] == 0} {puts $s "21"}
if {[ncgi::empty av_phono.x] == 0} {puts $s "22"}

puts [html::end]